

import java.io.*;
import java.awt.image.*;
import javax.imageio.*;

public class PaletteToGBA {

	public static void main(String[] args) {
		try {
			main(args[0], args[1]);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} System.exit(0);
	}

	public static void main(String palFilename, String outFilename)
	throws Exception {
		final char[] HEX = {
			'0', '1', '2', '3', '4', '5', '6', '7',
			'8', '9', 'A', 'B', 'C', 'D', 'E', 'F'
		};
		BufferedImage image;
		int width, height, palCount, index, pixel, index2;
		int[] pixels, palette;
		PrintWriter out;
		image = ImageIO.read(new File(palFilename));
		width = image.getWidth();
		height = image.getHeight();
		pixels = new int[width * height];
		image.getRGB(0, 0, width, height, pixels, 0, width);
		image.flush();
		image = null;
		palette = new int[16];
		palCount = index = 0;
		while (palCount < 16 && index < pixels.length) {
			pixel = pixels[index];
			//pixel &= 0x00F8F8F8;
			//pixel |= 0xFF000000;
			for (index2 = 0; index2 < palCount; index2++)
				if (palette[index2] == pixel)
					break;
			if (index2 == palCount)
				palette[palCount++] = pixel;
			index++;
		}
		pixels = null;
		out = new PrintWriter(
			new BufferedWriter(
				new OutputStreamWriter(
					new BufferedOutputStream(
						new FileOutputStream(
							outFilename
						)
					)
				)
			)
		);
		for (index = 0; index < palette.length; index++) {
			pixel = palette[index];
			out.print("0x");
			out.print(HEX[(pixel >> 20) & 0xF]);
			out.print(HEX[(pixel >> 16) & 0xF]);
			out.print(HEX[(pixel >> 12) & 0xF]);
			out.print(HEX[(pixel >>  8) & 0xF]);
			out.print(HEX[(pixel >>  4) & 0xF]);
			out.print(HEX[(pixel >>  0) & 0xF]);
			out.print(",\n");
		}
		out.flush();
		out.close();
	}

}


