

import java.io.*;
import java.awt.image.*;
import javax.imageio.*;

public class TilesToGBA {

	public static void main(String[] args) {
		try {
			main(args[0], args[1], args[2]);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} System.exit(0);
	}

	public static void main(
		String tileFilename,
		String palFilename,
		String outFilename
	) throws Exception {
		final char[] HEX = {
			'0', '1', '2', '3', '4', '5', '6', '7',
			'8', '9', 'A', 'B', 'C', 'D', 'E', 'F'
		};
		BufferedImage image;
		int width, height, palCount, index, pixel, index2;
		int tileX, tileY, x, y;
		int[] pixels, palette;
		PrintWriter out;
		image = ImageIO.read(new File(palFilename));
		width = image.getWidth();
		height = image.getHeight();
		pixels = new int[width * height];
		image.getRGB(0, 0, width, height, pixels, 0, width);
		image.flush();
		image = null;
		palette = new int[16];
		palCount = index = 0;
		while (palCount < 16 && index < pixels.length) {
			pixel = pixels[index];
			index2 = 0;
			for (index2 = 0; index2 < palCount; index2++)
				if (palette[index2] == pixel)
					break;
			if (index2 == palCount)
				palette[palCount++] = pixel;
			index++;
		} pixels = null;
		image = ImageIO.read(new File(tileFilename));
		width = image.getWidth();
		height = image.getHeight();
		pixels = new int[width * height];
		image.getRGB(0, 0, width, height, pixels, 0, width);
		image.flush();
		image = null;
		out = new PrintWriter(
			new BufferedWriter(
				new OutputStreamWriter(
					new BufferedOutputStream(
						new FileOutputStream(
							outFilename
						)
					)
				)
			)
		);
		for (tileY = 0; tileY < (height >> 3); tileY++) {
			for (tileX = 0; tileX < (width >> 3); tileX++) {
				index = (tileX << 3) + ((tileY << 3) * width);
				for (y = 0; y < 8; y++) {
					out.print("0x");
					for (x = 7; x >= 0; x--) {
						pixel = pixels[index + x +
							(y * width)];
						index2 = 0;
						while (index2 < 16) {
							if (palette[index2] ==
								pixel
							) {
								pixel = index2;
								break;
							} index2++;
						} if (index2 == 16)
							pixel = 0;
						out.print(HEX[pixel]);
					} out.print("U,\n");
				} out.print('\n');
			}
		}
		pixels = null;
		out.flush();
		out.close();
		out = null;
		System.out.println("Wrote " +
			((width >> 3) * (height >> 3)) + ".");
	}

}


